def pack_small(val):
    assert val >= 0
    return chr(int(val))

def pack_large(val):
    val = int(val)
    s = chr(val & 127)
    val = val >> 7
    while val > 0:
        x = val & 127
        x += 128
        s = chr(x) + s
        val >>= 7
    return s

def pack_string(val):
    val = val.encode("utf8")
    return pack_large(len(val)) + val

def unpack_small(fileobj):
    return ord(fileobj.read(1))

def unpack_large(fileobj):
    val = 0
    while True:
        c = ord(fileobj.read(1))
        if c >= 128:
            val += c & 127
            val <<= 7
        else:
            val += c
            break
    return val

def unpack_string(fileobj):
    size = unpack_large(fileobj)
    return fileobj.read(size).decode("utf8")

